#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Crawler (Linux/Unix Only)
# DIZ: Enables you to crawl for links to add to your Directory.
# GRAPHIC: ic_crawl.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any 
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "start2") { &start2; }
if ($q->param('fct') eq "add_category") { &add_category; }
if ($q->param('fct') eq "crawl_scr") { &crawl_scr; }
if ($q->param('fct') eq "index") { &index_sites; }
if ($q->param('fct') eq "clear") { &clear; }
if ($q->param('fct') eq "delall") { &delall; }
if ($q->param('fct') eq "delall_final") { &delall_final; }
if ($q->param('fct') eq "crawl_res_action") { &crawl_res_action; }
if ($q->param('fct') eq "move_links") { &move_links; }
if ($q->param('fct') eq "move_links_final") { &move_links_final; }
if ($q->param('fct') eq "save_edited") { &save_edited; }
if ($q->param('fct') eq "del") { &delete_crawcat; }
if ($q->param('fct') eq "delete_crawcat2") { &delete_crawcat2; }



##################################################################################
sub delete_crawcat2
{

$id = $q->param('id');

if ($q->param('B2') ne "")
	{
	&start2;
	}
	else
	{
if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "DELETE FROM crawlresults WHERE ccid = '$id'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 

$sql = "DELETE FROM crawlcats WHERE ccid = '$id'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 

$sth->finish;
$dbh->disconnect;


$hbox = acs::get_heading_box("$web_url/ic_crawl.gif", "Category Deleted", qq[
<a href="$admin_url/p_crawl.cgi?fct=start2">Click here to continue</a>
]);


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];
	
	}
	
}





sub delete_crawcat
{
$id = $q->param('id');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT * FROM crawlcats WHERE ccid = '$id'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
 
 while ( @row = $sth->fetchrow() )
 	{
	$category = $row[1];
	}

$sth->finish;
$dbh->disconnect;


$hbox = acs::get_heading_box("$web_url/ic_crawl.gif", "Are You Sure You Want To Delete '$category'? ", qq[
<form method="POST" action="$admin_url/p_crawl.cgi">
(If this category contains links then they will be lost.)<BR>

  <input type="hidden" name="fct" value="delete_crawcat2"><input type="hidden" name="id"
  value="$id"><p><input type="submit" value="   Yes   " name="B1"
  style="font-family: MS Sans Serif; font-size: 8"> <input type="submit" value="   No   "
  name="B2" style="font-family: MS Sans Serif; font-size: 8"></p>
</form>
]); 

print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];


}




sub delete_links
{
$id = $q->param('id');
$selstring= "";
$boxes_selected = $q->param('boxes_selected');

	for ($ms = 0; $ms < $boxes_selected; $ms++)
	 {
	$pname = "C" . $ms;
	if ($q->param($pname) ne "")
		{
		$del_rsid = $q->param($pname);
		$selstring = $selstring . " (resid = '$del_rsid') OR";
		}
	
	 }
$selstring = substr($selstring, 0, length($selstring) - 2);



if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "DELETE FROM crawlresults WHERE $selstring";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 

$sth->finish;
$dbh->disconnect;


$hbox = acs::get_heading_box("$web_url/ic_crawl.gif", "Links Deleted", qq[
<a href="$admin_url/p_crawl.cgi?fct=index&amp;id=$id">Click here to continue</a>
]);


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];

&recount_links($id);

}




sub save_edited
{

$id = $q->param('id');
$resids = $q->param('resids');

@allids = split (/-/, $resids);


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

foreach $item (@allids)
	{
	$title = "title_" . $item;
	$rtitle = $q->param($title); $rtitle =~ s/'/\\'/g;
	
	$description = "description_" . $item;
	$rdescription = $q->param($description); $rdescription =~ s/'/\\'/g;
	
	$keywords = "keywords_" . $item;
	$rkeywords = $q->param($keywords); $rkeywords =~ s/'/\\'/g;
	
	$url = "url_" . $item;
	$rurl = $q->param($url); $rurl =~ s/'/\\'/g;

	$sql = "UPDATE crawlresults SET 	title = '$rtitle',
												description = '$rdescription',
												keywords = '$rkeywords',
												url = '$rurl'
												WHERE resid = '$item'";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 

	}



$sth->finish;
$dbh->disconnect;

#########################

$hbox = acs::get_heading_box("$web_url/ic_crawl.gif", "Changes Saved", qq[
<a href="$admin_url/p_crawl.cgi?fct=index&amp;id=$id">Click Here to Continue</a>
]); 

print qq[
<html>

<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

}




sub move_links_final
{
$links_to_move = $q->param('links_to_move');
$movecat = $q->param('movecat');
$id = $q->param('id');
($cat_to_move_to, $tmp) = split (/___MVSPLT___/, $movecat);

@all_links = split (/-/, $links_to_move);
$link_number_counter=0;
foreach $item (@all_links)
	{
	$sql_links = $sql_links . "(resid = '$item') OR ";
	$link_number_counter++;
	}
	$sql_links = substr($sql_links, 0, length($sql_links) - 3);
	

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh2 = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh2 ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


$nowtime = time();

	$sql = "SELECT * FROM crawlresults WHERE $sql_links";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
	while ( @row = $sth->fetchrow() )
		{
		$title = $row[2]; $title =~ s/'/\\'/g;
		$description = $row[3]; $description =~ s/'/\\'/g;
		$keywords = $row[4]; $keywords =~ s/'/\\'/g;
		$url = $row[5]; $url =~ s/'/\\'/g;
		
		
		
		if ($q->param('duplc') eq "Y")
			{
			$rows = 0;
			$sqlsel = "SELECT url FROM links WHERE url = '$url'";
			$sth2 = $dbh2->prepare($sqlsel);
			$sth2->execute;
			$rows = $sth2->rows();
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
			
			#print "-> $sqlsel ooo $serror<BR>";
			
			if ($rows < 1)
				{
				$insert_sql = "INSERT INTO links SET 	cid = '$cat_to_move_to',
																	title = '$title',
																	description = '$description',
																	keywords = '$keywords',
																	url = '$url',
																	urldate = '$nowtime'";
				$sth2 = $dbh2->prepare($insert_sql);
				$sth2->execute;
				$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
				
				}
				else
				{
				$not_added = $not_added . "<b>$title</b><BR>$description<BR><a href=\"$url\">$url</a><BR><BR>";
				}
			}
			else
			{
			$insert_sql = "INSERT INTO links SET 	cid = '$cat_to_move_to',
																title = '$title',
																description = '$description',
																keywords = '$keywords',
																url = '$url',
																urldate = '$nowtime'";
			$sth2 = $dbh2->prepare($insert_sql);
			$sth2->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
			}
		

		
		}

if (defined($sth2)){$sth2->finish;} 
$dbh2->disconnect;

	$sql = "DELETE FROM crawlresults WHERE $sql_links";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 


############################
### UPDATE CATEGORY NUMBERS
############################


### GET CATEGORY NAME TO UPDATE CATEGORY NUMBERS

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sql = "SELECT cid, l1, l2, l3, l4, l5, l6, l7, l8, l9, l10, l11, l12, l13, l14, l15, l16, shortname
					FROM dirs WHERE cid = '$cat_to_move_to'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

$nrcounter = 0;
while ( @row = $sth->fetchrow() )
	{
		$cats = "";
		for ($ms = 1; $ms < 17; $ms++) 
				{
				if ($row[$ms] ne "")
					{
					$cats = $cats . $row[$ms] . "::-::";
					}
				} 
		$cats = substr($cats, 0, length($cats) - 5);
	} 

@to_update_cat = split (/::-::/, $cats);

$lvc = 1;
foreach $catlevel (@to_update_cat)
	{
	$catlevel =~ s/'/\\'/g;
	
	$levelsql = $levelsql . " (l" . $lvc . " = '$catlevel') AND";
	
	$use_levelsql = $levelsql . " (l" . ($lvc + 1) . " = '')";
	
	$sql = "UPDATE dirs SET linknrs = linknrs + $link_number_counter WHERE $use_levelsql";
	
	#print "--> $sql <BR>";
	
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
	
	$lvc++;
	
	}

if (defined($sth)){$sth->finish; } 
$dbh->disconnect;


$cats =~ s/::-::/ >> /g;


if ($not_added ne "")
	{
	$not_added = qq[
	<p class="normaltext"><strong>The following links was not added as it would
create duplicates:</strong></span><BR><blockquote>] . $not_added . "</blockquote>";
	}


$hbox = acs::get_heading_box("$web_url/ic_crawl.gif", "Links Moved", qq[
Links was moved to: <b>$cats</b><br>
<a href="$admin_url/p_crawl.cgi?fct=index&amp;id=$id">Click here to continue</a>
<p>$not_added</p>
]);


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

#print "--> $cats<BR>";
#print "NR: $link_number_counter<BR>";
#print "MOVE COMPLETE!";

&recount_links($id);

}





sub recount_links
{
my ($catid) = @_;

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT count(*) FROM crawlresults WHERE ccid = '$catid'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
 
 while ( @row = $sth->fetchrow() )
 	{
	$cnumber = $row[0];
	}

$sql = "UPDATE crawlcats SET linksnumber = '$cnumber' WHERE ccid = '$catid'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 

$sth->finish;
$dbh->disconnect;


}






sub crawl_res_action
{

$boxes_selected = $q->param('boxes_selected');

	for ($ms = 0; $ms < $boxes_selected; $ms++)
	 {
	$pname = "C" . $ms;
	if ($q->param($pname) ne "")
		{
		$selstring = $selstring . "$pval-";
		}
	
	 }

if ($selstring eq "") 
	{ 
	 acs::problem_popup("You have to select something."); exit; 
	}

###################################

if ($q->param('B1') ne "")
	{
	if ($q->param('selval') eq "move"){&move_links;}
	if ($q->param('selval') eq "edit"){&edit_links;}
	if ($q->param('selval') eq "delete"){&delete_links;}
	}
	elsif ($q->param('B2') ne "")
	{
	if ($q->param('selval1') eq "move"){&move_links;}
	if ($q->param('selval1') eq "edit"){&edit_links;}
	if ($q->param('selval1') eq "delete"){&delete_links;}
	}



}








sub edit_links
{

$boxes_selected = $q->param('boxes_selected');
$id = $q->param('id');

$selstring = "";
	for ($ms = 0; $ms < $boxes_selected; $ms++)
	 {
	$pname = "C" . $ms;
	if ($q->param($pname) ne "")
		{
		$selvalue = $q->param($pname);
		$selstring = $selstring . " (resid = '$selvalue') OR";
		$resids = $resids . $q->param($pname) . "-";
		}
	
	 }
	$selstring = substr($selstring, 0, length($selstring) -2);
	$resids = substr($resids, 0, length($resids) -1);


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


$sql = "SELECT * FROM crawlresults WHERE $selstring";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
 
 while ( @row = $sth->fetchrow() )
 	{
 	$title = "title_" . $row[0];
 	$description = "description_" . $row[0];
 	$keywords = "keywords_" . $row[0];
 	$url = "url_" . $row[0];
 	
$edit_boxes = $edit_boxes . qq[


<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#D8D8D8">
  <tr>
    <td width="100%" height="30" colspan="2" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Listing
    Details:</strong></td>
  </tr>
  <tr>
    <td width="10%" height="30" bgcolor="#FFFFFF" class="normaltext">Title: </td>
    <td width="90%" height="30" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="$title" size="95"
    value="$row[2]"> </td>
  </tr>
  <tr>
    <td width="10%" height="30" valign="top" bgcolor="#FFFFFF" class="normaltext">Description: </td>
    <td width="90%" height="30" bgcolor="#FFFFFF" class="normaltext"><textarea rows="6" name="$description"
    cols="71">
$row[3]
</textarea> </td>
  </tr>
  <tr>
    <td width="10%" height="30" bgcolor="#FFFFFF" class="normaltext">Keywords: </td>
    <td width="90%" height="30" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="$keywords"
    size="95" value="$row[4]"> </td>
  </tr>
  <tr>
    <td width="10%" height="30" bgcolor="#FFFFFF" class="normaltext">URL: </td>
    <td width="90%" height="30" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="$url" size="95"
    value="$row[5]"> </td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>
];
	
	}


$sth->finish;
$dbh->disconnect;


$crawl_cat = $q->param('crawl_cat');

$hbox = acs::get_heading_box("$web_url/ic_crawl.gif", "Editing Crawled Link Listings", qq[
<a href="$admin_url/p_crawl.cgi?fct=start2"><b>Crawler Home</b></a>
&gt;&gt; Crawler Category: <a href="$admin_url/p_crawl.cgi?fct=index&amp;id=$id"><b>$crawl_cat</b></a>
&gt;&gt; Editing Crawled Links
]); 

print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox

<form method="POST" action="$admin_url/p_crawl.cgi">
  <input type="hidden" name="fct" value="save_edited">
  <input type="hidden" name="id" value="$id">
  <input type="hidden" name="resids" value="$resids">
$edit_boxes

<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#C0C0C0">
  <tr>
    <td width="10%" bgcolor="#FFFFFF" height="30"></td>
    <td width="90%" bgcolor="#FFFFFF" height="30"><input type="submit" value="     Save     "
    name="B1"></td>
  </tr>
</table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
</table>
</form>





</body>
</html>
];


}





sub move_links
{

$id = $q->param('id');
$boxes_selected = $q->param('boxes_selected');
$crawl_cat = $q->param('crawl_cat');
$crawl_cat2 = $q->param('crawl_cat'); $crawl_cat2 =~ s/ /+/g;

#### GET LINKS TO MOVE

if ($boxes_selected ne "")
	{
	$selstring = "mitems=";
	for ($ms = 0; $ms < $boxes_selected; $ms++)
	 {
	$pname = "C" . $ms;
	if ($q->param($pname) ne "")
		{
		$pval = $q->param($pname);
		$selstring = $selstring . "$pval-";
		$hselstring = $hselstring . "$pval-";
		}
	
	 }
   chop($selstring);
   chop($hselstring);
   
	}
	else
	{
	$selstring = "mitems=" . $q->param('mitems');
	$hselstring = $q->param('mitems');
	}


########

$ct = $q->param('ct'); ### ORIGINAL CAT
$cid = $q->param('cid'); ### ORIGINAL CID
$rid = $q->param('rid'); ### ORIGINAL RID

$mct = $q->param('mct'); ### TO MOVE TO CAT
$mlv = $q->param('mlv'); ### TO MOVE LEVEL
$mcid = $q->param('mcid'); ### TO MOVE CID

$last_dname = acs::get_last_dirname($mct);

########

$location = acs::get_location_string ($ct);

########

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
 
########

if ($mlv == 0)
	{
	$sth = $dbh->prepare("SELECT * FROM dirs WHERE (level = '1') AND ((crosslinkid IS NULL) OR (crosslinkid < 1)) ORDER BY shortname ASC");
	}
	else
	{
	$mlv++;
	@adir = split (/-/, $mct);
	
	$querystr = "";

	for ($ms = 0; $ms < 16; $ms++) 
		{
		if ($adir[$ms] ne "") {$adir[$ms] = acs::decode_dir($adir[$ms]);}

		$acnt = $ms + 1;
		if ($acnt != $mlv)
			{
			if ($adir[$ms] ne "")
				{
				$adir[$ms] =~ s/'/\\'/g;
				}
			$querystr = $querystr . " (l" . "$acnt = '$adir[$ms]') and";
			}
		$acnt++;
		}
	$querystr = substr($querystr, 0, length($querystr) - 3);
	$sth = $dbh->prepare("SELECT * FROM dirs WHERE (level = '$mlv') AND $querystr AND ((crosslinkid IS NULL) OR (crosslinkid < 1)) ORDER BY shortname ASC");
	
	}

##############

if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }

$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$rows = $sth->rows();

$smc = 0;
while ( @row = $sth->fetchrow() )
	{
	$mlv = $row[1];

	$row[2] = acs::encode_dir($row[2]); $dirstring = $row[2];														#1
	if ($row[3] ne "") { $row[3] = acs::encode_dir($row[3]); $dirstring =   $dirstring . "-$row[3]"; } #2
	if ($row[4] ne "") { $row[4] = acs::encode_dir($row[4]); $dirstring =   $dirstring . "-$row[4]"; } #3
	if ($row[5] ne "") { $row[5] = acs::encode_dir($row[5]); $dirstring =   $dirstring . "-$row[5]"; } #4
	if ($row[6] ne "") { $row[6] = acs::encode_dir($row[6]); $dirstring =   $dirstring . "-$row[6]"; } #5
	if ($row[7] ne "") { $row[7] = acs::encode_dir($row[7]); $dirstring =   $dirstring . "-$row[7]"; } #6
	if ($row[8] ne "") { $row[8] = acs::encode_dir($row[8]); $dirstring =   $dirstring . "-$row[8]"; } #7
	if ($row[9] ne "") { $row[9] = acs::encode_dir($row[9]); $dirstring =   $dirstring . "-$row[9]"; } #8
	if ($row[10] ne ""){ $row[10] = acs::encode_dir($row[10]); $dirstring = $dirstring ."-$row[10]"; } #9
	
	if ($row[11] ne ""){ $row[10] = acs::encode_dir($row[11]); $dirstring = $dirstring ."-$row[11]"; } #10
	if ($row[12] ne ""){ $row[10] = acs::encode_dir($row[12]); $dirstring = $dirstring ."-$row[12]"; } #11
	if ($row[13] ne ""){ $row[10] = acs::encode_dir($row[13]); $dirstring = $dirstring ."-$row[13]"; } #12
	if ($row[14] ne ""){ $row[10] = acs::encode_dir($row[14]); $dirstring = $dirstring ."-$row[14]"; } #13
	if ($row[15] ne ""){ $row[10] = acs::encode_dir($row[15]); $dirstring = $dirstring ."-$row[15]"; } #14
	if ($row[16] ne ""){ $row[10] = acs::encode_dir($row[16]); $dirstring = $dirstring ."-$row[16]"; } #15
	if ($row[17] ne ""){ $row[10] = acs::encode_dir($row[17]); $dirstring = $dirstring ."-$row[17]"; } #16

	if ($row[20] eq "") { $row[20] = 0; }

	$locked_stat = "";
	if ($row[22] eq "Y") { $locked_stat = " <img src=\"$web_url/locked.gif\">"; }

	if ($last_dname eq "") { $last_dname = "Root "; }
	if ($smc == 0) 
		{
		$movedirs = $movedirs . " <img src=\"$web_url/dir.gif\"> <b>$last_dname</b> <br>";
		$selbox = "checked";
		}
		else
		{
		$selbox = "";
		}
	$smc++;
	
	$moveval = "$row[0]" . "___MVSPLT___" . "$row[28]";
	
	$movedirs = $movedirs . "<input type=\"radio\" name=\"movecat\" $selbox value=\"$moveval\"> <img src=\"$web_url/subdir.gif\"> <a href=\"$admin_url/p_crawl.cgi?mlv=$mlv&mct=$dirstring&cid=$cid&rid=$rid&ct=$ct&fct=move_links&$selstring&opaction=$opaction&$newsub&id=$id&crawl_cat=$crawl_cat2\">$row[28]</a></strong> ($row[20]) $locked_stat<br>";
	}

$sth->finish;
$dbh->disconnect;

#### CURRENT MOVE LOCATION

if ($mct eq "")
	{
	$currentloc = "Root ";
	}
	else
	{
	$currentloc = "<a href=\"$admin_url/p_crawl.cgi?mlv=&mct=&cid=$cid&rid=$rid&ct=$ct&fct=move_links&$selstring&opaction=$opaction&$newsub&id=$id&crawl_cat=$crawl_cat2\">Root</a> ";
	
	$n_mlv = 1;
	
	@allds = split (/-/, $mct);
	$ccnr = @allds;

	foreach $aitem (@allds)
		{
		$n_mct = $n_mct . $aitem . "-";
		
		$cdname = acs::decode_dir($aitem);
		
		$cnn_mct = substr($n_mct, 0, length($n_mct) - 1);
		
		if ($ccnr ne $n_mlv)
			{
			$currentloc = $currentloc . " >> <a href=\"$admin_url/p_crawl.cgi?mlv=$n_mlv&mct=$cnn_mct&cid=$cid&rid=$rid&ct=$ct&fct=move_links&$selstring&opaction=$opaction&$newsub&id=$id&crawl_cat=$crawl_cat2\">$cdname</a> ";
			}
			else
			{
			$currentloc = $currentloc . " >> $cdname ";
			}
		
		$n_mlv++;
		}
	
	}

#### 

if ($dirstring !~ /-/)
	{
	$pmct = "";
	}
	else
	{
	$pmct = "$mct";
	}


#####

if ($mlv eq "")
	{
	$create_lv = 0;
	}
	else
	{
	$create_lv = $mlv -1;
	}

if ($rows == 0)
	{
$movedirs = <<END_OF_NONE;

<p><font color="#FF8000"><strong>This category contains no sub categories/directories. <br>
</strong></font>Use the back button of your browser to go back.</p>

END_OF_NONE
	}
	else
	{
if ($opaction eq "Copy")
		{
		$movebut = "<input type=\"submit\" value=\"   Copy   \" name=\"movebutton\">";
		}
		else
		{
		$movebut = "<input type=\"submit\" value=\"   Move   \" name=\"movebutton\">";
		}
	}

###############

if ($opaction eq "Copy")
	{
	$move_title = "Copy Listings";
	$movew = "Copy";
	$faction = "copy_operation";
	}
	else
	{
	$move_title = "Move Listings From Crawled Category";
	$movew = "Move";
	$faction = "move_operation";
	}

###############	

if ($q->param('newsub') eq "true")
	{
	$location = "New Submissions";
	}




if ($q->param('newsub') eq "other") ### IF MOVING LINKS FROM SOMEWHERE ELSE (NOT NEW SUBMISSIONS OR DIR MANAGER)
	{
	$movecgi = "$admin_url/admin56.cgi";
	}
	else ### IF MOVING FROM NEW SUBMISSIONS OR DIR MANAGER
	{
	$movecgi = "$admin_url/p_crawl.cgi";
	}
	



$hbox = acs::get_heading_box("$web_url/ic_crawl.gif", "$move_title", qq[

<form method="POST" action="$admin_url/p_crawl.cgi">
  <input type="hidden" name="fct" value="move_links_final"><input type="hidden" name="ct"
  value="$ct"><input type="hidden" name="links_to_move" value="$hselstring"><input
  type="hidden" name="cid" value="$cid"><input type="hidden" name="rid" value="$rid"><input
  type="hidden" name="mct" value="$pmct"><input type="hidden" name="newsub" value="$newsub2"><input
  type="hidden" name="email" value="$newsubemail"><input type="hidden" name="id" value="$id"><p> 

  <b><a href="$admin_url/p_crawl.cgi?fct=start2">Crawler Home </a>&gt;&gt;  
  Crawler Category: <a href="$admin_url/p_crawl.cgi?fct=index&amp;id=$id">$crawl_cat </a>&gt; &gt; Moving Crawled
  Links </b></p>
  <p>$movew Listings To: <br>
  <img src="$web_url/lar.gif" width="6" height="10"> <b>$currentloc </b></p>
  
	<p>$movedirs</p>
  
  <p><input type="checkbox" name="duplc" value="Y" checked> Do not add links that would
  create duplicates. (Checked against URLs) </p>
  <p>$movebut <input type="submit" value="   Add Dir    " name="createdir"
  onClick="popup('$admin_url/admin2.cgi?fct=addir&amp;ct=$mct&amp;lv=$create_lv&amp;mscr=mscr',600,400);return false;">
  </p>
  
</form>

]);



$helpb = acs::quick_help("Quick Help",qq[
Navigate through the categories/directories above by clicking on the category names. Once you have found the appropriate directory/category, select it and click the $movew button.
]); 


print <<END_OF_MVL;

<html>
<head>
<title>$move_title</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">

<script LANGUAGE="JavaScript">
<!-- Hide

  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
	var random = parseInt(Math.random()*10000)

	  var popupwin = null;
      myWindow = open (loc, popupwin + random, myspecs);
      myWindow.moveTo(100,40);
      myWindow.focus();

    }

 // End Hide -->
</script>

</head>
<body>

$hbox

$helpb

</body>
</html>


END_OF_MVL

#&ct=$mct&lv=$create_lv&mscr=mscr







}



sub delall_final
{

if ($q->param('B1') eq "   Yes   ")
{

$id = $q->param('id');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "DELETE FROM crawlresults WHERE ccid = '$id'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
 
$sth->finish;
$dbh->disconnect;


$hbox = acs::get_heading_box("$web_url/ic_crawl.gif", "Links Deleted", qq[
<a href="$admin_url/p_crawl.cgi?fct=index&amp;id=$id">Click here to continue</a>
]);
  

print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];


&recount_links($id);

}
else
{
&index_sites;
}



}




sub delall
{

$id = $q->param('id');

$hbox = acs::get_heading_box("$web_url/add.gif", "Delete All Links", qq[
<form method="POST" action="$admin_url/p_crawl.cgi?fct=delall_final">
<input type="hidden" name="id" value="$id">
<input type="hidden" name="fct" value="delall_final">
Are you sure you want to delete all links in this category? <input type="submit" value="   Yes   " name="B1"
  style="font-family: MS Sans Serif; font-size: 8"> <input type="submit" value="    No    " name="B1" style="font-family: MS Sans Serif; font-size: 8"></p>
</form>
]);


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>



];


}



##########
sub clear
{

opendir(DIR,"$data_dir/crawler");
@files = readdir(DIR);
closedir(DIR); 


foreach $item (@files)
	{
	if (($item ne ".") and ($item ne ".."))
		{
		$tmp = unlink("$data_dir/crawler/$item");  
		}
	}



$hbox = acs::get_heading_box("$web_url/ic_crawl.gif", "Temporary Files Cleared", qq[
<a href="$admin_url/p_crawl.cgi?fct=start2">Click Here to Continue</a>
]);



print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];



}



sub start
{


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

#$wsql = "SHOW TABLES FROM $db_name";
$wsql = "SHOW TABLES";
$sth = $dbh->prepare($wsql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
while ( @row = $sth->fetchrow() )
	{
	if ($row[0] eq "crawlcats") { $crawlcats_tbl_found = "True"; }
	if ($row[0] eq "crawlresults") { $crawlresults_tbl_found = "True"; }	
	}


if ($crawlresults_tbl_found ne "True")
	{

	$sql = 			  "CREATE TABLE crawlresults
							(
							resid				int NOT NULL auto_increment,
							ccid				int,
							title				varchar(255),
							description		text,
							keywords			varchar(255),
							url				varchar(255),
							
							PRIMARY 	KEY(resid),
							INDEX (ccid)
							)  TYPE=MyISAM";
							
		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

	}


if ($crawlcats_tbl_found ne "True")
	{
	$sql = 			  "CREATE TABLE crawlcats
							(
							ccid			int NOT NULL auto_increment,
							catname		varchar(255),
							linksnumber int,

							PRIMARY 	KEY(ccid)
							)  TYPE=MyISAM";
							
		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

	}


$sth->finish;
$dbh->disconnect;



$hbox = acs::get_heading_box("$web_url/ic_crawl.gif", "Terms of Use and Disclaimer - Please Read - Important", qq[
<p>The PowerSeek Crawler Plug-in is distributed 'as is' and on an 'as available' basis. <br>
<br>
This crawler may overload the system/machine and/or web server if to many threads are open
at once. It may also crash a web server if to many threads are being opened at once. If
you are not able to monitor the load of the server then please do not crawl with more than
10 threads at a time. If you are on a shared server/host then it may place considerable
load on the server of your hosting company. In this instance do not crawl with more than 5
threads per crawl. Crawling with threads has the advantage of speeding up the fetching of
web pages but the more threads are open the higher the load on a server. <br>
<br>
By pressing the agree button below, you agree that FocalMedia.net shall not be liable for
the termination of a hosting account by a host for overloading their server.
FocalMedia.net shall also not be liable for any damages, losses, loss of profits, data
losses, and/or causes of action due to the use of the PowerSeek Crawler Plug-in. </p>

<form method="POST" action="$admin_url/p_crawl.cgi">
  <input type="hidden" name="fct" value="start2"><div align="center"><center><p><input
  type="submit" value="  I Agree to the Terms of Use and Disclaimer" name="B1"> </p>
  </center></div>
</form>
]);



print qq[

<html>

<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>

<body>
$hbox
</body>
</html>

];


}





sub index_sites
{

$id = $q->param('id');


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT * FROM crawlcats WHERE ccid = '$id'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
 
 while ( @row = $sth->fetchrow() )
 	{
	$category = $row[1];
	}
 

### FIND OUT HOW MUCH RESULTS TO DISPLAY PER PAGE

if ($q->param('perpage') ne "") 
	{ 
		open (STP, "> $data_dir/crawler2.cfg");
			print STP $q->param('perpage');
		close (STP);
	}

$links_per_page = &get_file_contents("$data_dir/crawler2.cfg");  

if ($links_per_page eq "") { $links_per_page = 20; }

if ($links_per_page == 10)  { $v10 = "selected"; }
if ($links_per_page == 20)  { $v20 = "selected"; }
if ($links_per_page == 30)  { $v30 = "selected"; }
if ($links_per_page == 50)  { $v50 = "selected"; }
if ($links_per_page == 100) { $v100 = "selected"; }
if ($links_per_page == 200) { $v200 = "selected"; }
if ($links_per_page == 300) { $v300 = "selected"; }
if ($links_per_page == 500) { $v500 = "selected"; }




### FETCH RESULTS

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT * FROM crawlresults WHERE ccid = '$id' ORDER BY title";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
$rows = $sth->rows(); 



### PREPARE PAGES

$icnt = $rows;
$nr_searchres = $links_per_page;

$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$ippc = 1; 


$checkbox_counter = 0;
 while ( @row = $sth->fetchrow() )
 	{

if (($ippc > $st) and ($ippc <= $nd))
    {
 	
 	$cboxname = "C" . $checkbox_counter;
 	
 	$check_allvals = $check_allvals . "'C" . $checkbox_counter . "',";
 	
$crawl_results = $crawl_results . qq[
<table border="0" cellpadding="3" cellspacing="1" width="100%">
  <tr>
    <td width="1%%" valign="top"><input type="checkbox" name="$cboxname" value="$row[0]"> </td>
    <td width="99%" class="normaltext">$ippc. <a href="$row[5]" target="_blank">$row[2] </a><br>
    $row[3] <br>
    <b>Keywords: </b>$row[4] <br>
    <b>$row[5] </b><br>
    <br>
    <br>
    </td>
  </tr>
</table>
			];
	
		$checkbox_counter++;
		} 
	$ippc++;		
	}

$sth->finish;
$dbh->disconnect;

$check_allvals = substr($check_allvals, 0, length($check_allvals) - 1);


#### PAGES

for ($ms = 0; $ms < $pages; $ms++) 
	{
	$pg = $ms + 1;
	if ($nd == ($pg * $nr_searchres))
		{
		$pgstring = $pgstring . " [$pg] ";
		$targpage = $pg;
		}
	  	else
		{
		$st1 = ($pg * $nr_searchres) - $nr_searchres;
		$nd1 = ($pg * $nr_searchres);
		$pgstring = $pgstring . "<a href=\"$admin_url/p_crawl.cgi?st=$st1&nd=$nd1&fct=index&id=$id\">$pg</a> ";
		}
	}

if ($pages > 1)
	{
	$pgstring = "Pages: " . $pgstring;
	}
	else
	{
	$pgstring = "";
	}




### NEXT / PREV PAGES

$spls = $modp;
if ($spls == 0){$spls++;}

 if ($nd <= ($icnt - $spls))
 	{
	$st1 = $st + $nr_searchres;
	$nd1 = $nd + $nr_searchres;
	$nextt = "<a href=\"$admin_url/p_crawl.cgi?st=$st1&nd=$nd1&fct=index&id=$id\">Next Page >></a> ";
	}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		$prev = "<a href=\"$admin_url/p_crawl.cgi?st=$st1&nd=$nd1&fct=index&id=$id\"><< Prev Page</a> ";
		}

if (($prev ne "") and ($nextt ne ""))
	{
	$spcer = " | ";
	}
	else
	{
	$spcer = " ";
	}
	  
	$prevnext = $prev . "$spcer" . $nextt;

	if (length($prevnext) > 5){$myspacer = " | ";}

	

if ($pages > 1)
	{
	$prevnext = "$prevnext $myspacer Page $targpage of $pg";
	}
	else
	{
	$prevnext = "";
	} 



if ($rows > 0)
{

if (($prevnext ne "") and ($pgstring ne ""))
	{
	$optprevn = qq[

  <table border="0" cellpadding="6" cellspacing="1" width="100%">
    <tr>
      <td width="50%" class="normaltext">$prevnext</td>
      <td width="50%" align="right" valign="top" class="normaltext">$pgstring </td>
    </tr>
  </table>	
	
	];
	
	}


$pg_details = qq[

<form method="POST" action="$admin_url/p_crawl.cgi">
  <input type="hidden" name="fct" value="index"><input type="hidden" name="id" value="$id">

<table border="0" cellpadding="6" cellspacing="0" width="100%"
  style="border: 1px solid rgb(218,218,218)">
    <tr>
      <td width="50%" background="$web_url/bar6.gif" class="normaltext"><strong>Found $rows Links in Total </strong></td>
      <td width="50%" align="right" valign="top" background="$web_url/bar6.gif" class="normaltext"><select name="perpage" size="1"
      style="font-family: MS Sans Serif; font-size: 8">
        <option value="10" $v10> List 10 Links Per Page </option>
        <option value="20" $v20> List 20 Links Per Page </option>
        <option value="30" $v30> List 30 Links Per Page </option>
        <option value="50" $v50> List 50 Links Per Page </option>
        <option value="100" $v100> List 100 Links Per Page </option>
        <option value="200" $v200> List 200 Links Per Page </option>
        <option value="300" $v300> List 300 Links Per Page </option>
        <option value="500" $v500> List 500 Links Per Page </option>
      </select> <input type="submit" value="  Go  " name="B1"
      style="font-family: MS Sans Serif; font-size: 8"> </td>
    </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
$optprevn

</form>

];


}

if($rows > 1)
{

$listings = qq[

<form method="POST" action="$admin_url/p_crawl.cgi" name="select_all">
<input type="hidden" name="fct" value="crawl_res_action">
<input type="hidden" name="id" value="$id">
<input type="hidden" name="boxes_selected" value="$checkbox_counter">
<input type="hidden" name="crawl_cat" value="$category">



<table border="0" cellpadding="6" cellspacing="1" width="100%"
style="border: 1px solid rgb(218,218,218)">
  <tr>
    <td width="50%" background="$web_url/bar6.gif" class="normaltext"><select name="selval" size="1"
    style="font-family: MS Sans Serif; font-size: 8">
      <option value="move"> Move Selected Links to PowerSeek Categories </option>
      <option value="edit"> Edit Selected Links </option>
      <option value="delete"> Delete Selected Links </option>
    </select> <input type="submit" value="  Go  " name="B1"
    style="font-family: MS Sans Serif; font-size: 8"> </td>
    <td width="50%" align="right" valign="middle" background="$web_url/bar6.gif" class="normaltext"><a
    href="javascript:checkall('select_all',true)"><b>Check All</b> </a>| <a
    href="javascript:checkall('select_all',false)"><b>UnCheck All</b> </a>| <a
    href="$admin_url/p_crawl.cgi?fct=delall&amp;id=$id"><b>Delete All Links</b> </a></td>
  </tr>
</table>

  
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
  <BR>

$crawl_results


<table border="0" cellpadding="6" cellspacing="1" width="100%"
style="border: 1px solid rgb(218,218,218)">
  <tr>
    <td width="50%" class="normaltext" background="$web_url/bar6.gif"><select name="selval1"
    size="1" style="font-family: MS Sans Serif; font-size: 8">
      <option value="move"> Move Selected Links to PowerSeek Categories </option>
      <option value="edit"> Edit Selected Links </option>
      <option value="delete"> Delete Selected Links </option>
    </select> <input type="submit" value="  Go  " name="B2"
    style="font-family: MS Sans Serif; font-size: 8"> </td>
    <td width="50%" align="right" valign="middle" class="normaltext"
    background="$web_url/bar6.gif"><strong><a href="javascript:checkall('select_all',true)">Check
    All </a>| <a href="javascript:checkall('select_all',false)">UnCheck All </a>| <a
    href="$admin_url/p_crawl.cgi?fct=delall&amp;id=$id">Delete All Links </a></strong></td>
  </tr>
</table>
 <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>

<table border="0" cellpadding="6" cellspacing="1" width="100%">
  <tr>
    <td width="50%" class="normaltext">$prevnext</td>
    <td width="50%" align="right" valign="top" class="normaltext">$pgstring</td>
  </tr>
</table>
</form>
];
	
	
}
else
{

$listings = qq[
<p>There are no links that has been crawled in this
category. <a href="$admin_url/p_crawl.cgi?fct=crawl_scr&amp;ccid=$id">Click here</a> to
crawl for links to be placed inside this category.</p>
];


}



$hbox = acs::get_heading_box("$web_url/ic_crawl.gif", "Move Crawled Sites Into Categories", qq[
Choose sites that you would like to categories below for <br>
<b><a href="$admin_url/p_crawl.cgi?fct=start2">Crawler Home</a> &gt;&gt; Crawler Category: <b>$category</b></b>
]);



print qq[

<html>
<head>
<title>Crawler</title>

<script LANGUAGE="JavaScript">
<!-- Hide

function checkall(formname,thestate)
	{
	BoxNames=new Array($check_allvals)
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c])
		boxname.checked = thestate
		}
	}

// -->
</script>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>

<body>

$hbox

$pg_details

$listings


</body>
</html>
];


}




sub crawl_scr
{

$ccid = $q->param('ccid');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT * FROM crawlcats WHERE ccid = '$ccid'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
 
 while ( @row = $sth->fetchrow() )
 	{
	$category = $row[1];
	}
 
$sth->finish;
$dbh->disconnect;


$hbox = acs::get_heading_box("$web_url/ic_crawl.gif", "Set up Crawler", qq[
The links you are about to crawl will be placed inside:<br>
<strong><ul>
<p>$category</p>
</ul>
<p>
</strong>When the crawler has completed it's crawl you may then review what has been crawled to include and categorise it into your Directory.
]);


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox



<form method="POST" action="$admin_url/pcrawl2.cgi">
  <input type="hidden" name="ccid" value="$ccid"><input type="hidden" name="fct"
  value="do_crawl"><table border="0" cellpadding="6" cellspacing="1" width="100%"
  bgcolor="#DADADA">
    <tr>
      <td width="101%" height="30" colspan="2" valign="top"
      background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Crawler Settings </strong></td>
    </tr>
    <tr>
      <td width="44%" height="25" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Number of Crawler
      Threads to Open: </strong></td>
      <td width="57%" height="25" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="threads" size="4"
      value="10"> </td>
    </tr>
    <tr>
      <td width="44%" height="41" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Crawler Time Out: </strong><br>
      (If a connection is not reached within this time then the connection to the URL to be
      crawled will be aborted) </td>
      <td width="57%" height="41" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="timeout" size="4"
      value="20"> Seconds </td>
    </tr>
    <tr>
      <td width="44%" height="28" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Number of links to
      retrieve from Google.com: <br>
      </strong>The first link results will always be the most relevant to your keywords. </td>
      <td width="57%" height="28" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="googlenr" size="7"
      value="50"> </td>
    </tr>
    <tr>
      <td width="44%" height="25" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Keywords to Search For
      at Google.com </strong></td>
      <td width="57%" height="25" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="keywords" size="30"
      value="$category"> </td>
    </tr>
    <tr>
      <td width="44%" height="25" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Include Crawled links
      that has no meta description? <br>
      </strong>(Recommended to be off) </td>
      <td width="57%" height="25" bgcolor="#FFFFFF" class="normaltext"><input type="checkbox" name="metadiz"
      value="Y"> </td>
    </tr>
    <tr>
      <td width="44%" height="27" valign="top" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="57%" height="27" bgcolor="#FFFFFF" class="normaltext"><input type="submit" value="Start Crawling"
      name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>



</body>
</html>


];



}



sub add_category
{

$catname = $q->param('catname');

if ($catname eq "") 
{ acs::problem_popup("You have to provide a category name."); exit; }

$catname =~ s/'/\\'/g; 

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "INSERT INTO crawlcats SET catname = '$catname'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
$rows = $sth->rows();  
 
$sth->finish;
$dbh->disconnect;


$hbox = acs::get_heading_box("$web_url/ic_crawl.gif", "Category Created", qq[
<a href="$admin_url/p_crawl.cgi?fct=start2">Click here to continue</font></a>
]);


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

}





sub start2
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT * FROM crawlcats ORDER BY catname";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
 
 while ( @row = $sth->fetchrow() )
 	{
 	$nr = $row[2]; if ($nr eq "") { $nr = o; }
 	
$table_middle = $table_middle . qq[  <tr>
 <tr>
    <td width="70%" class="normaltext">$row[1] ($nr) </td>
    <td width="10%" class="normaltext" align="center"><a
    href="$admin_url/p_crawl.cgi?fct=crawl_scr&amp;ccid=$row[0]">Crawl </a></td>
    <td width="10%" class="normaltext" align="center"><a
    href="$admin_url/p_crawl.cgi?fct=index&amp;id=$row[0]">Index </a></td>
    <td width="10%" class="normaltext" align="center"><a
    href="$admin_url/p_crawl.cgi?fct=del&amp;id=$row[0]">Delete </a></td>
  </tr>
];
	}
 
$sth->finish;
$dbh->disconnect;





if ($table_middle eq "")
	{

$ctable = qq[
<ul>
  <li class="normaltext">There are at present no categories. The crawler will place links that it has crawled
    into categories that you create. Let's say for example that you would like to crawl links
    about 'Batman comic books'. You would then for example create a category called: 'Batman
    Comic Books' or something related. Once the category has been created you can enter it and
    start crawling for sites about 'Batman comic books'. All links found will then be placed
    in the 'Batman Comic Books' category for your review. From there you can move the links
    that you would like inside your Directory to your PowerSeek Directory. </li>
</ul>
<BR>
];
	
	}
	else
	{
	
$ctable = qq[

<table border="0" cellpadding="6" cellspacing="1" width="100%"
style="border: 1px solid rgb(218,218,218)">
  <tr>
    <td width="70%" background="$web_url/bar6.gif" class="normaltext"><strong>Category Name </strong></td>
    <td width="10%" align="center" background="$web_url/bar6.gif" class="normaltext"><strong>Crawl </strong></td>
    <td width="10%" align="center" background="$web_url/bar6.gif" class="normaltext"><strong>Indexing </strong></td>
    <td width="10%" align="center" background="$web_url/bar6.gif" class="normaltext"><strong>Delete </strong></td>
  </tr>
 $table_middle
</table>


	<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
	  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
	</table>
 

];
	
	
	}


opendir(DIR,"$data_dir/crawler");
@files = readdir(DIR);
closedir(DIR); 

$nrfiles = @files;

if ($nrfiles > 3)
	{

$clear_files = qq[


<table border="0" cellpadding="6" cellspacing="1" width="100%"
style="border: 1px solid rgb(218,218,218)">
  <tr>
    <td width="100%" height="28" valign="top" background="$web_url/bar6.gif"
    class="normaltext"><strong>Temporary Crawl Swap Files Found. </strong></td>
  </tr>
  <tr>
    <td width="101%" height="38" valign="top" class="normaltext">At times the crawler will
    leave swap files behind in the event when a browser window is closed while crawling or
    other unforseen circumstances. It will also use these files to cache certain data. It is
    recommended that you clear these files if no crawl is currently in progress. <blockquote>
      <p><strong><a href="$admin_url/p_crawl.cgi?fct=clear">Click here if you would like the
      clear these temporary files. (Recommended) </a>&nbsp;&nbsp; </strong></p>
    </blockquote>
    </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
    <td width="147%"></td>
  </tr>
</table>
];

	}



$hbox = acs::get_heading_box("$web_url/ic_crawl.gif", "PowerSeek Crawler", qq[

<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="90%" valign="top" class="normaltext">Use the crawler to crawl for web sites to be categorised into
    your Directory. The crawler will fetch URLs from Google.com for the keywords you specify.
    It will then crawl these URLs for titles, meta descriptions and meta keywords. Once you
    have crawled for sites you can review what has been crawled to include and categorize it
    into your Directory. </td>
    <td width="5%" valign="top" align="right"><a href="$admin_url/help.cgi?fct=pcrawl"
    target="_blank"><strong><img src="$web_url/bhelps.gif" border="0"> </strong></a></td>
  </tr>
</table>

]);

print qq[

<html>

<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>

<body>

$hbox

$ctable

<form method="POST" action="$admin_url/p_crawl.cgi">
  <input type="hidden" name="fct" value="add_category"><div align="center"><center><table
  border="0" cellpadding="6" cellspacing="1" width="100%"
  style="border: 1px solid rgb(218,218,218)">
    <tr>
      <td width="100%" height="28" colspan="2" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Add
      a New Category: </strong></td>
    </tr>
    <tr>
      <td width="7%" height="38" valign="top" class="normaltext"><strong>Name: </strong></td>
      <td width="94%" height="38" class="normaltext"><input type="text" name="catname" size="54"> <input type="submit" value="Add"
      name="  add  "> </td>
    </tr>
  </table>
  </center></div><div align="center"><center><table border="0" cellpadding="0"
  cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="147%"></td>
    </tr>
  </table>
  </center></div>
</form>

$clear_files

</body>
</html>

];



}




sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

